unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, SNMPSynapse, SNMPSend;

type
  TForm1 = class(TForm)
    HostEdit: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    CommunityEdit: TEdit;
    Memo1: TMemo;
    Memo2: TMemo;
    Label5: TLabel;
    Label6: TLabel;
    GroupBox1: TGroupBox;
    Label4: TLabel;
    OidGetEdit: TEdit;
    Button1: TButton;
    GroupBox2: TGroupBox;
    Label7: TLabel;
    OidSetEdit: TEdit;
    Button2: TButton;
    ValueEdit: TEdit;
    Label8: TLabel;
    ValueTypeComboBox: TComboBox;
    Label9: TLabel;
    SNMPSynapse1: TSNMPSynapse;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
var
  response: string;
  //n: integer;
begin
  SNMPSynapse1.Host := HostEdit.Text;
  SNMPSynapse1.Community := CommunityEdit.Text;
  response := SNMPSynapse1.SNMPget(OidGetEdit.Text);
  if (response <> SNMP_FAILURE) and (response <> '') then
  begin
    label2.Caption := 'Success...';
    memo1.Lines.Clear;
    memo2.Lines.Clear;
    memo1.Lines.Text := response;
    {s := '';
    for n := 0 to Length(response) do
      s := s + '$' + IntToHex(Ord(response[n]), 2) + ' ';
    memo2.Lines.Text := s;}
  end
  else
  begin
    label2.Caption := 'Not contacted... (Check SNMP host, community or MIB OID!)';
    memo1.Lines.Clear;
    memo2.Lines.Clear;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  response, s: string;
  ValueType: TSNMPMibValueType;
  //n: integer;
begin
  ValueType := smvtNull;
  if (ValueTypeComboBox.Text = 'Integer') then ValueType := smvtInteger;
  if (ValueTypeComboBox.Text = 'OctetString') then ValueType := smvtOctetString;
  if (ValueTypeComboBox.Text = 'Null') then ValueType := smvtNull;
  if (ValueTypeComboBox.Text = 'ObjectId') then ValueType := smvtObjectId;
  if (ValueTypeComboBox.Text = 'Sequence') then ValueType := smvtSequence;
  if (ValueTypeComboBox.Text = 'IpAddress') then ValueType := smvtIpAddress;
  if (ValueTypeComboBox.Text = 'Counter') then ValueType := smvtCounter;
  if (ValueTypeComboBox.Text = 'Gauge') then ValueType := smvtGauge;
  if (ValueTypeComboBox.Text = 'TimeTicks') then ValueType := smvtTimeTicks;

  SNMPSynapse1.Host := HostEdit.Text;
  SNMPSynapse1.Community := CommunityEdit.Text;
  response := SNMPSynapse1.SNMPset(OidSetEdit.Text, ValueEdit.Text, ValueType);
  if (response <> SNMP_FAILURE) and (response <> '') then
   begin
    label2.Caption := 'Success...';
    memo1.Lines.Clear;
    memo2.Lines.Clear;
    memo1.Lines.Text := response;
    s := '';
    //for n := 0 to Length(response) do
    //  s := s + '$' + IntToHex(Ord(response[n]), 2) + ' ';
    memo2.Lines.Text := s;
  end
  else
  begin
    label2.Caption := 'Not contacted... (Check SNMP host, community or MIB OID!)';
    memo1.Lines.Clear;
    memo2.Lines.Clear;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  ValueTypeComboBox.ItemIndex := 0;
end;

end.

